package de.laliluna.example;

import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;


import org.hibernate.HibernateException;
import org.hibernate.Session;

public class HibernateJsfListener implements PhaseListener {
	private static org.slf4j.Logger log = org.slf4j.LoggerFactory.getLogger(HibernateJsfListener.class);

	/*
     * (non-Javadoc)
     * 
     * @see javax.faces.event.PhaseListener#afterPhase(javax.faces.event.PhaseEvent)
     */
	public void afterPhase(PhaseEvent arg0) {
		// if we find an active transaction, we will roll it back
		try {
			Session session = InitSessionFactory.getInstance()
					.getCurrentSession();
			if (session.getTransaction().isActive()) {
				session.getTransaction().rollback();
				log.debug("Rolled back transaction");
			}
		} catch (RuntimeException e) {
			log.error("Error rolling back transaction");
		}
	}

	/*
     * (non-Javadoc)
     * 
     * @see javax.faces.event.PhaseListener#beforePhase(javax.faces.event.PhaseEvent)
     */
	public void beforePhase(PhaseEvent arg0) {

	}

	/*
     * (non-Javadoc)
     * 
     * @see javax.faces.event.PhaseListener#getPhaseId()
     */
	public PhaseId getPhaseId() {
		return PhaseId.RENDER_RESPONSE;
	}

}
