package de.laliluna.example.jsf;

import java.util.Locale;
import java.util.ResourceBundle;

import javax.faces.application.Application;
import javax.faces.context.FacesContext;

public class Globals {

	public static final String SUCCESS = "success";

	public static final String FAILURE = "failure";

	/**
	 * gets a message from the application ressource bundle
	 * @param key
	 * @param locale
	 * @return
	 */
	public static String getText(String key, Locale locale){
		if (locale == null)
			locale = FacesContext.getCurrentInstance().getViewRoot().getLocale();
		Application application = FacesContext.getCurrentInstance().getApplication();
		ResourceBundle bundle = ResourceBundle.getBundle(application.getMessageBundle(), locale);
		
		return bundle.getString(key);
	}
}
