package de.laliluna.example.struts;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ExceptionHandler;
import org.apache.struts.config.ExceptionConfig;
import org.hibernate.HibernateException;

import de.laliluna.example.InitSessionFactory;

public class SevereExceptionHandler extends ExceptionHandler {
	private static org.slf4j.Logger log = org.slf4j.LoggerFactory.getLogger(SevereExceptionHandler.class);

	/*
     * (non-Javadoc)
     * 
     * @see org.apache.struts.action.ExceptionHandler#execute(java.lang.Exception,
     *      org.apache.struts.config.ExceptionConfig,
     *      org.apache.struts.action.ActionMapping,
     *      org.apache.struts.action.ActionForm,
     *      javax.servlet.http.HttpServletRequest,
     *      javax.servlet.http.HttpServletResponse)
     */
	@Override
	public ActionForward execute(Exception ex, ExceptionConfig ae,
			ActionMapping mapping, ActionForm formInstance,
			HttpServletRequest request, HttpServletResponse response)
			throws ServletException {

		/*
         * we will try to clean the Hibernate session before continuing with
         * default behaviour
         */

		try {
			org.hibernate.Transaction transaction = InitSessionFactory
					.getInstance().getCurrentSession().getTransaction();
			if (transaction.isActive())
				transaction.rollback();
			log.debug("Rolled back transaction after exception.");
		} catch (RuntimeException e) {
			log.error("Error rolling back transaction");
		}

		return super.execute(ex, ae, mapping, formInstance, request, response);
	}

}
