package de.laliluna.dialogue;

import javax.ejb.Local;
import javax.ejb.Remove;
import javax.ejb.Stateful;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceContextType;

import de.laliluna.sandcastle.Sandcastle;
import de.laliluna.sandcastle.Sandcastle.Color;

@Stateful
@Local(SandcastleWizard.class)
public class SandcastleWizardBean implements SandcastleWizard {

	private Sandcastle sandcastle;
	
	@PersistenceContext(type=PersistenceContextType.EXTENDED)
	private EntityManager em;

	/* (non-Javadoc)
	 * @see de.laliluna.dialogue.SandcastleWizard#step1()
	 */
	@TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
	public void step1() {
		sandcastle = new Sandcastle();
		em.persist(sandcastle);
	}

	/* (non-Javadoc)
	 * @see de.laliluna.dialogue.SandcastleWizard#step2(java.lang.String)
	 */
	@TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
	public void step2(String name) {
		sandcastle.setName(name);
	}

	/* (non-Javadoc)
	 * @see de.laliluna.dialogue.SandcastleWizard#step3(java.lang.String)
	 */
	@Remove
	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	public Sandcastle step3(String color) {
		// null pointer fix
		if (color == null)
			color = "";
		if (color.equalsIgnoreCase(Color.BLUE.toString()))
			sandcastle.setColor(Color.BLUE);
		else if (color.equalsIgnoreCase(Color.RED.toString()))
			sandcastle.setColor(Color.RED);
		else if (color.equalsIgnoreCase(Color.YELLOW.toString()))
			sandcastle.setColor(Color.YELLOW);
		else
			sandcastle.setColor(Color.GREEN);
		return sandcastle;
	}
}
