package de.laliluna.search;

import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;
import org.hibernate.cfg.Configuration;
import org.hibernate.service.ServiceRegistry;
import org.hibernate.service.ServiceRegistryBuilder;

public class SessionFactoryUtil {
	private static SessionFactory factory;
	
	private SessionFactoryUtil() {
	}
	
	static{
        final Configuration cfg = new Configuration();
        cfg.configure();
        final ServiceRegistry serviceRegistry = new ServiceRegistryBuilder()
                .applySettings(cfg.getProperties())
                .buildServiceRegistry();
        factory = cfg.buildSessionFactory(serviceRegistry);
	}
	
	public static SessionFactory getFactory(){
		return factory;
	}
	
}
