
package de.laliluna.component.collection2;

import java.util.List;

import org.hibernate.LockOptions;
import org.hibernate.Session;

import de.laliluna.example.BasicTest;
import de.laliluna.hibernate.InitSessionFactory;


public class TestComponentCollection2 extends BasicTest {

	/**
     * @param args
     */
	public static void main(String[] args) {
		Pizza pizza = create();
		update(pizza);
		query();

	}

	private static void query() {
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		List<Pizza> list = session
				.createQuery(
						"from Pizza c left join c.ingredients a where a.name = :ingr")
				.setString("ingr", "Tomato").list();
		for (Pizza client : list) {
			System.out.println(client);
		}

		session.getTransaction().commit();
	}

	private static void update(Pizza pizza) {
		log.debug("update");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		// reattach hedgehog as session could have been closed
		session.buildLockRequest(LockOptions.NONE).lock(pizza);
		// delete with index does not work
		pizza.getIngredients().remove(0);
		session.flush();
		// delete of address will work
		Ingredient address = (Ingredient) pizza.getIngredients()
				.iterator().next();
		pizza.getIngredients().remove(address);
		session.flush();

		Ingredient newAddress = new Ingredient("Tomato");
		pizza.getIngredients().add(newAddress);

		session.getTransaction().commit();

	}

	private static Pizza create() {
		log.debug("create");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		Pizza pizza = new Pizza(null, "Peter");
		Ingredient address1 = new Ingredient("Salami");
		Ingredient address2 = new Ingredient("Cheese");
		pizza.getIngredients().add(address1);
		pizza.getIngredients().add(address2);
		session.save(pizza);
		session.getTransaction().commit();
		return pizza;
	}

}
