
package de.laliluna.inheritance.joineddiscriminator;

import java.util.Iterator;
import java.util.List;

import org.hibernate.LockMode;
import org.hibernate.LockOptions;
import org.hibernate.Session;

import de.laliluna.example.BasicTest;
import de.laliluna.hibernate.InitSessionFactory;


public class TestJoinedDiscriminator extends BasicTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		MusicFan musicFan = create();
		update(musicFan);
		query();

	}

	private static void query() {
		log.debug("query");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		List list = null;
		session.beginTransaction();

		log.debug("select all HardRockGroups");
		list = session.createQuery("from HardrockGroup").list();
		for (Iterator iter = list.iterator(); iter.hasNext();) {
			HardrockGroup element = (HardrockGroup) iter.next();
			log.debug("{}",element);
		}

		log.debug("select all MusicGroups beeing HardRockGroups");
		list = session.createQuery(
				"from MusicGroup mg where mg.class = HardrockGroup").list();

		for (Iterator iter = list.iterator(); iter.hasNext();) {
			MusicGroup element = (MusicGroup) iter.next();
			log.debug("{}",element);
		}

		log
				.debug("select all HardRockgroups having destroyed more than 150 guitars");
		/*
		 * we do not need to express that we are only looking for HardRockGroups
		 * mg.class = HardrockGroup is optional but it makes the query
		 * considerably faster.
		 */
		list = session
				.createQuery(
						"from MusicGroup mg where  mg.class = HardrockGroup and mg.destroyedGuitars>150")
				.list();

		for (Iterator iter = list.iterator(); iter.hasNext();) {
			MusicGroup element = (MusicGroup) iter.next();
			log.debug("{}",element);
		}

		/*
		 * select all musicFans of hardrockgroups having destroyed more than 150
		 */
		log.debug("select all  musicFans of hardrockgroups");
		list = session
				.createQuery(
						"select mf from MusicFan mf  where  mf.musicGroups.id  in "
								+ " (select hg.id from HardrockGroup hg where hg.destroyedGuitars > 150)")
				.list();
		System.exit(0);
		for (Iterator iter = list.iterator(); iter.hasNext();) {

			log.debug("{}", iter.next());
		}

		session.getTransaction().commit();

	}

	private static void update(MusicFan musicFan) {
		log.debug("update");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		// we expect the session to be closed so reattach internetshop to move
		// it to persistent status
		session.buildLockRequest(LockOptions.NONE).lock(musicFan);
		// we stop offering cash payment in this shop

		session.getTransaction().commit();
	}

	private static MusicFan create() {
		log.debug("create");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		MusicFan musicFan = new MusicFan("Edwin");
		HardrockGroup hardrockGroup = new HardrockGroup();
		hardrockGroup.setName("very brutal");
		hardrockGroup.setDestroyedGuitars(200);
		musicFan.getMusicGroups().add(hardrockGroup);
		BoyGroup boyGroup = new BoyGroup();
		boyGroup.setName("nice guys");
		boyGroup.setCryingGroupies(true);
		musicFan.getMusicGroups().add(boyGroup);
		// save the payment methods first, because the shop needs the primary
		// keys
		session.save(boyGroup);
		session.save(hardrockGroup);
		session.save(musicFan);
		session.getTransaction().commit();
		return musicFan;
	}

}
