
package de.laliluna.inheritance.union;

import java.util.Iterator;
import java.util.List;

import org.hibernate.LockMode;
import org.hibernate.LockOptions;
import org.hibernate.Session;

import de.laliluna.example.BasicTest;
import de.laliluna.hibernate.InitSessionFactory;


public class TestUnion extends BasicTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		MusicConsumer musicConsumer = create();
		update(musicConsumer);
		query();

	}

	private static void query() {
		log.debug("query");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		List list = null;
		session.beginTransaction();

		log.debug("select all GirlGroups");
		list = session.createQuery(
				"from MusicBand mg where mg.class = GirlGroup").list();

		for (Iterator iter = list.iterator(); iter.hasNext();) {
			MusicBand element = (MusicBand) iter.next();
			log.debug("{}", element);
		}

		log
				.debug("select all SoftRockgroups having destroyed less than 50 guitars");
		/*
		 * we do not need to express that we are only looking for SoftrockGroup
		 * mg.class = SoftrockGroup is optional but it makes the query
		 * considerably faster.
		 */
		list = session
				.createQuery(
						"from MusicBand m where  m.class = SoftrockGroup and m.destroyedGuitars<50")
				.list();
		for (Iterator iter = list.iterator(); iter.hasNext();) {
			MusicBand element = (MusicBand) iter.next();
			log.debug("{}", element);
		}

		
		log.debug("select all  musicFans of SoftRockGroup");
		list = session
				.createQuery(
						"select m from MusicConsumer m left join m.musicGroups mg where mg.class = SoftrockGroup")
				.list();
		/*
		 * select all musicConsumer of softrockgroups having destroyed more than
		 * 150
		 */
		log.debug("select all  musicFans of SoftRockGroup");
		list = session
				.createQuery(
						"select m from MusicConsumer m  where  m.musicGroups.id  in "
								+ " (select s.id from SoftrockGroup s where s.destroyedGuitars > 150)")
				.list();
		for (Iterator iter = list.iterator(); iter.hasNext();) {

			log.debug("{}", iter.next());
		}

		session.getTransaction().commit();

	}

	private static void update(MusicConsumer musicFan) {
		log.debug("update");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		// we expect the session to be closed so reattach internetshop to move
		// it to persistent status
		session.buildLockRequest(LockOptions.NONE).lock(musicFan);
		// we stop offering cash payment in this shop

		session.getTransaction().commit();

	}

	private static MusicConsumer create() {
		log.debug("create");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		MusicConsumer musicConsumer = new MusicConsumer("Edwin");
		SoftrockGroup softrockGroup = new SoftrockGroup();
		softrockGroup.setName("very brutal");
		softrockGroup.setDestroyedGuitars(200);
		musicConsumer.getMusicGroups().add(softrockGroup);
		GirlGroup girlGroup = new GirlGroup();
		girlGroup.setName("nice girls");
		girlGroup.setCryingGroupies(true);
		musicConsumer.getMusicGroups().add(girlGroup);
		// save the payment methods first, because the shop needs the primary
		// keys
		session.save(girlGroup);
		session.save(softrockGroup);
		session.save(musicConsumer);
		session.getTransaction().commit();
		return musicConsumer;
	}

}
