package com.example.newapp.pages;

import com.example.newapp.domain.Book;
import org.apache.tapestry5.annotations.InjectPage;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.hibernate.annotations.CommitAfter;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.hibernate.Session;


public class CreateBook {

    /*
    @Property makes the book available to the EditBook.tml page.
     */
    @Property
    private Book book;

    @Inject
    private Session session;

    /*
    Inject a page. It is used later for navigation purpose.
     */
    @InjectPage
    private Index index;

    /**
     * Commit the transaction using {@code session.getTransaction().commit()} right after the
     * method was executed.
     */
    @CommitAfter
    Object onSuccess() {
        session.saveOrUpdate(book);
        /*
        Return the injected page to navigate to the page.
         */
        return index;
    }
}
