package de.laliluna.cachetest;

import java.util.Iterator;
import java.util.Random;

import net.sf.ehcache.Cache;
import net.sf.ehcache.CacheException;
import net.sf.ehcache.CacheManager;


import org.hibernate.Session;

import de.laliluna.hibernate.InitSessionFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class RandomGetThread extends Thread {

	private int max = 10;

    final static Logger log = LoggerFactory.getLogger(RandomGetThread.class);

    public void run() {

		log.info("##############starting: " + this);

		randomAccess();

	}

	private void randomAccess() {
		Random random = new Random(System.currentTimeMillis() / this.getId());
		

		long total = 0;
		long start = 0;
		long totalTime = 0;
		long timePerRequest = 0;

		try {
			CacheManager cacheManager = CacheManager.getInstance();
			Cache cache = cacheManager.getCache("myCache");
			for (int i = 0; i < 401; i++) {
				Session session = InitSessionFactory.getInstance().getCurrentSession();
				session.beginTransaction();
				start = System.currentTimeMillis();
				Developer d = (Developer) session.get(Developer.class,
						1 + random.nextInt(1000));
				if (d != null){
    				for (Iterator iter = d.getComputers().iterator(); iter
    						.hasNext();) {
    					Computer element = (Computer) iter.next();
    				}
				}
				timePerRequest = (System.currentTimeMillis() - start);
				total += timePerRequest;
				totalTime += timePerRequest;
				session.getTransaction().commit();

				if (i % 100 == 0 && i > 0) {
					double average = (total) / 100.0;

					log.info("### Thread: " + this + " Hit count: "
							+ cache.getLiveCacheStatistics().getCacheHitCount() + " Size: "
							+ cache.getMemoryStoreSize() + " total:" + total
							+ " access speed per 100 get: " + average);

					total = 0;
				}
				// short pause, we do not want to saturate the cpu
				try {
					sleep(100);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		
		} catch (CacheException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		log.info("################# finish: " + this + " total time: "
				+ totalTime);

	}
}
