package de.laliluna.cachetest;

import java.util.Iterator;
import java.util.List;
import java.util.Random;

import net.sf.ehcache.Cache;
import net.sf.ehcache.CacheException;
import net.sf.ehcache.CacheManager;


import org.hibernate.Session;

import de.laliluna.hibernate.InitSessionFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class RandomQueryThread extends Thread {

	private boolean cacheQuery;
	final static Logger log = LoggerFactory.getLogger(RandomQueryThread.class);
	
	public RandomQueryThread(boolean cacheQuery){
		this.cacheQuery=cacheQuery;
	}
	

	public void run() {
		log.info("##############starting: " + this);
		randomQuery();
		
	}

	/**
	 * mesures time needed to show result of two queries
	 * 
	 */
	private void randomQuery() {
		Random random = new Random(System.currentTimeMillis() / this.getId());
		Session session = InitSessionFactory.getInstance().getCurrentSession();

		long total = 0;
		long totalQuery=0;
		long start = 0;
		long totalTime = 0;

		try {
			CacheManager cacheManager = CacheManager.getInstance();
			Cache cache = cacheManager.getCache("myCache");
			for (int i = 0; i < 70; i++) {
				session = InitSessionFactory.getInstance().getCurrentSession();
				session.beginTransaction();
				start = System.currentTimeMillis();
				String param = ""+random.nextInt(10)+"%";
			
				List result = session.createQuery(
						"from Computer c where c.name like ? order by c.name desc, c.id asc").setString(0,
						param).setCacheable(cacheQuery).list();
				totalQuery += System.currentTimeMillis()-start;
				for (Iterator iter = result.iterator(); iter.hasNext();) {
					Computer element = (Computer) iter.next();
					element.getName();

				}
				total += (System.currentTimeMillis() - start);
				session.getTransaction().commit();


				if (i % 1 == 0) {
					double average = (total) / 100.0;

					log.info("### Thread: " + this + " Hit count: "
							+ cache.getLiveCacheStatistics().getCacheHitCount() + " Size: "
							+ cache.getMemoryStoreSize() + "total: " + total+" totalquery : "+totalQuery
							+ " access speed per 100 get: " + average);
totalTime += totalQuery;
					total = 0;
					totalQuery = 0;
				}
				// short pause, we do not want to saturate the cpu
				try {
					sleep(200);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		} catch (CacheException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		log.info("################# finish: " + this + " total query time: " + totalTime);
	}
}
