package de.laliluna.cachetest;

import java.util.Random;


import org.hibernate.Session;

import de.laliluna.hibernate.InitSessionFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TestTransactionThread extends Thread {

    final static Logger log = LoggerFactory.getLogger(TestTransactionThread.class);

	private boolean isReader;

	public TestTransactionThread(boolean isReader) {
		this.isReader = isReader;
	}

	public void run() {
	
		log.info("##############starting: " + this);
		if (isReader)
			readValues();
		else
		
		writeValues();

	}

	private void writeValues() {
		log.debug("write values");
		Random r = new Random();
		String newName;
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		log.debug("open transaction");
		session.beginTransaction();

		Developer developer = (Developer) session.get(Developer.class, 1);
		try {
			sleep(2000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		log.debug("write developer");
		newName = "" + r.nextInt();
		developer.setName(newName);
		try {
			sleep(2000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		log.debug("commit transaction");
		session.getTransaction().commit();

	}

	private void readValues() {
		log.debug("Read values");
		Session session = null;
		for (int i = 0; i < 6; i++) {
			session =  InitSessionFactory.getInstance().getCurrentSession();

			session.beginTransaction();

			Developer developer = (Developer) session.get(Developer.class, 1);
			log.debug("Read: " + developer.getName());
			session.getTransaction().commit();
			session.close();
			try {
				sleep(2000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}

	}

}
